
#include "Header.h"


Camera::Camera()
{
	camera           = NULL;
	CurrentDistance  = 100.0f;
	DefaultDistance  = 100.0f;
	Box.Min.X = Box.Min.Y = Box.Min.Z = -2.0f;
	Box.Max.X = Box.Max.Y = Box.Max.Z =  2.0f;

	geVec3d_Set(&Translation,0.0f,0.0f,0.0f);
	geVec3d_Set(&Rotation,0.0f,0.0f,0.0f);
}

Camera::~Camera()
{
	if(camera)
	{
		geCamera_Destroy(&camera);
		camera = NULL;
	}
}

bool Camera::Create()
{
	Rect.Left   = 0;
	Rect.Top    = 0;
	Rect.Right  = CD->getm_Engine()->getWidth() - 1;
	Rect.Bottom = CD->getm_Engine()->getHeight() - 1;

	camera = geCamera_Create(2.0f,&Rect);

	if(!camera)
		return false;

	geCamera_SetZScale(camera,1.0f);

	return true;
}

bool Camera::CreateCamera()
{
	Create();

	return 1;
}

void Camera::SetTranslation(float X,float Y,float Z)
{
	Translation.X = X;
	Translation.Y = Y;
	Translation.Z = Z;
}

void Camera::SetRotation(float X,float Y,float Z)
{
	Rotation.X = X;
	Rotation.Y = Y;
	Rotation.Z = Z;
}

void Camera::WorldSpaceXForm()
{
	geVec3d      front,back;
	geVec3d      pos;
	geVec3d      orient;
	geVec3d      atranslation,arotation;
	float        x;
	GE_Collision collision;

	atranslation    = CD->getm_PlayerManager()->getm_Player(TYPE_SPAWN)->getTranslation();
	atranslation.Y += CD->getm_PlayerManager()->getm_Player(TYPE_SPAWN)->getHeight();
	arotation       = CD->getm_PlayerManager()->getm_Player(TYPE_SPAWN)->getRotation();
	arotation.Y    += 3.14159f;

//	atranslation    = CD->getm_Player()->getTranslation();
//	atranslation.Y += CD->getm_Player()->getHeight();
//	arotation       = CD->getm_Player()->getRotation();
//	arotation.Y    += 3.14159f;

	geXForm3d_SetIdentity(&XForm);

	geXForm3d_RotateZ(&XForm,arotation.Z);
	geXForm3d_RotateX(&XForm,arotation.X);
	geXForm3d_RotateY(&XForm,arotation.Y);

	geXForm3d_Translate(&XForm,atranslation.X,atranslation.Y,atranslation.Z);

	pos = XForm.Translation;
	geXForm3d_GetIn(&XForm,&Direction);
	geVec3d_AddScaled(&pos,&Direction,CurrentDistance,&back);
	geVec3d_AddScaled(&pos,&Direction,0.0f,&front);

	if(geWorld_Collision(CD->getm_World()->getWorld(),&Box.Min,&Box.Max,&front,&back,GE_VISIBLE_CONTENTS,GE_COLLIDE_ALL,0xffffffff,NULL,NULL,&collision))
	{
		CurrentDistance = (float)fabs(geVec3d_DistanceBetween(&collision.Impact,&front));

		if(CurrentDistance < 0.0f)
			CurrentDistance = 0.0f;
		else
		if(CurrentDistance > DefaultDistance)
			CurrentDistance = DefaultDistance;
		
		geVec3d_AddScaled(&pos,&Direction,CurrentDistance,&back);
	}

	CurrentDistance = DefaultDistance;

	geXForm3d_SetIdentity(&XForm);
	geVec3d_Subtract(&pos,&back,&orient);

	if(CurrentDistance > 0.0f)
	{
		x = orient.X;
		
		orient.X = (float)(GE_PI * 0.5f) - (float)acos(orient.Y / CurrentDistance);
		orient.Y = (float)atan2(x,orient.Z) + GE_PI;
		orient.Z = 0.0f;
	}

	geXForm3d_RotateZ(&XForm,orient.Z);
	geXForm3d_RotateX(&XForm,orient.X);
	geXForm3d_RotateY(&XForm,orient.Y);
	geXForm3d_Translate(&XForm,back.X,back.Y,back.Z);
	
	geCamera_SetWorldSpaceXForm(camera,&XForm);
	geCamera_SetAttributes(camera,2.0f,&Rect);
}