
#include "Header.h"


Common::Common()
{
	m_State         = STATE_MAINMENU;
	m_Looped        = false;
	m_Engine        = NULL;
	m_Camera        = NULL;
	m_World         = NULL;
	m_Font          = NULL;
	m_PlayerManager = NULL;
	m_Keyboard      = NULL;

	for(int n = 0; n < MAX_NUMBER_OF_SOUNDS; n++)
		m_Sound[n] = NULL;

	m_Menu          = NULL;
	m_Corona        = NULL;
}

Common::~Common()
{
	Destroy();
}

bool Common::CreateCommon(HINSTANCE hInstance)
{
	m_Engine = new Engine();
	N_DETECT_NULL(m_Engine,"Unable to allocate memory to m_Engine");
	N_DETECT(m_Engine->CreateEngine(hInstance),"failed to call m_Engine->CreateEngine(hInstance)");

	m_Camera = new Camera();
	N_DETECT_NULL(m_Camera,"Uanble to allocate memory to m_Camera");
	N_DETECT(m_Camera->CreateCamera(),"failed to call m_Camera->CreateCamera()");

/*	m_World = new World();
	N_DETECT_NULL(m_World,"Unable to allocate memory to m_World");
	N_DETECT(m_World->Loadbsp("bsp\\gedit1.bsp"),"failed to call m_World->Loadbsp()");
*/
	m_Keyboard = new Keyboard();
	N_DETECT_NULL(m_Keyboard,"Unable to alloacte memory to m_Keyboard");
	
	m_Font = new TTFont();
	N_DETECT_NULL(m_Font,"Uanble to allocate memory to m_Font");
	N_DETECT(m_Font->LoadFont(),"failed to call m_Font->LoadFont()");

/*	m_PlayerManager = new PlayerManager();
	N_DETECT_NULL(m_PlayerManager,"Unable to allocate memory to m_PlayerManager");
	m_PlayerManager->Load();
*/
	for(int n = 0; n < MAX_NUMBER_OF_SOUNDS; n++)
	{
		m_Sound[n] = new Sound();
		N_DETECT_NULL(m_Sound[n],"Unable to allocate memory to m_Sound");
	}

	m_Sound[SOUND_ACQUIRE] ->Load("wav\\acquire.wav");
	m_Sound[SOUND_CLICK]   ->Load("wav\\click.wav");

	m_Menu = new Menu();
	N_DETECT_NULL(m_Menu,"Unable to allocate memory to m_Menu");
	m_Menu->Load();

/*	LoadEntity();

	m_Corona = new Corona();
	N_DETECT_NULL(m_Corona,"Unable to allocate memory to m_Corona");
*/
	return true;
}

void Common::RenderWorld()
{
	switch(CD->getm_State())
	{
		case STATE_MAINMENU:
			CD->getm_Menu()->Process();
			break;
		case STATE_START:
			if(!m_Looped)
			{
				m_World = new World();
				N_DETECT_NULL(m_World,"Unable to allocate memory to m_World");
				N_DETECT(m_World->Loadbsp("bsp\\gedit1.bsp"),"failed to call m_World->Loadbsp()");

				m_PlayerManager = new PlayerManager();
				N_DETECT_NULL(m_PlayerManager,"Unable to allocate memory to m_PlayerManager");
				m_PlayerManager->Load();

				LoadEntity();

				m_Corona = new Corona();
				N_DETECT_NULL(m_Corona,"Unable to allocate memory to m_Corona");
			}
			
			CD->setState(STATE_MAINLOOP);
			m_Looped = true;
			break;
		case STATE_EXIT:
			DestroyWindow(CD->getm_Engine()->gethWnd());
			break;
		case STATE_MAINLOOP:
			CD->getm_Engine()->Begin();
			CD->getm_Camera()->WorldSpaceXForm();
				
			CD->getm_Engine()->Render();

			CD->getm_PlayerManager()->getm_Player(ID_SPAWN)->Control();
			CD->getm_PlayerManager()->getm_Player(ID_SPAWN)->Update();
		
			CD->getm_Corona()->Render();
			CD->getm_Engine()->End();
			break;
	}
}

void Common::Destroy()
{
	N_DELETE(m_Corona);
		
	DeleteEntity();

	N_DELETE(m_Menu);
	
	for(int n = 0; n < MAX_NUMBER_OF_SOUNDS; n++)
		N_DELETE(m_Sound[n]);

	N_DELETE(m_Keyboard);
	N_DELETE(m_PlayerManager);
	N_DELETE(m_Font);
	N_DELETE(m_World);
	N_DELETE(m_Camera);
	N_DELETE(m_Engine);
}