
#ifndef _COMMON_H_
#define _COMMON_H_

#define N_DETECT(n,m)      { if(!n)        { MessageBox(CD->getm_Engine()->gethWnd(),m,"Error",MB_OK); Destroy(); } }
#define N_DETECT_NULL(n,m) { if(n == NULL) { MessageBox(CD->getm_Engine()->gethWnd(),m,"Error",MB_OK); Destroy(); } }
#define N_DELETE(n)        { if(n) delete (n); n = NULL; }

class Common
{
public:
	Common();
   ~Common();

    void setState(int state);
    bool CreateCommon(HINSTANCE hInstance);
	void RenderWorld();
	void Destroy();

	bool           m_Looped;
	
	int            getm_State();
	Engine        *getm_Engine();
	Camera        *getm_Camera();
	World         *getm_World();
	TTFont        *getm_Font();
	PlayerManager *getm_PlayerManager();
	Keyboard      *getm_Keyboard();
	Sound         *getm_Sound(int ID);
	HUD           *getm_HUD();
	Menu          *getm_Menu();
	Corona        *getm_Corona();
	DynamicLight  *getm_DLight();

private:
	int            m_State;
	Engine        *m_Engine;
	Camera        *m_Camera;
	World         *m_World;
	TTFont        *m_Font;
	PlayerManager *m_PlayerManager;
	Keyboard      *m_Keyboard;
	Sound         *m_Sound[MAX_NUMBER_OF_SOUNDS];
	HUD           *m_HUD;
	Menu          *m_Menu;
	Corona        *m_Corona;
	DynamicLight  *m_DLight;
};

inline void           Common::setState(int state)  { m_State = state;        }
inline int            Common::getm_State()         { return m_State;         }
inline Engine        *Common::getm_Engine()        { return m_Engine;        }
inline Camera        *Common::getm_Camera()        { return m_Camera;        }
inline World         *Common::getm_World()         { return m_World;         }
inline TTFont        *Common::getm_Font()          { return m_Font;          }
inline PlayerManager *Common::getm_PlayerManager() { return m_PlayerManager; }
inline Keyboard      *Common::getm_Keyboard()      { return m_Keyboard;      }
inline Sound         *Common::getm_Sound(int ID)   { return m_Sound[ID];     }
inline HUD           *Common::getm_HUD()           { return m_HUD;           }
inline Menu          *Common::getm_Menu()          { return m_Menu;          }
inline Corona        *Common::getm_Corona()        { return m_Corona;        }
inline DynamicLight  *Common::getm_DLight()        { return m_DLight;        }

#endif