
#include "Header.h"

Dummy::Dummy()
{
	actor         = NULL;
	def           = NULL;
	motion        = NULL;
	counter       = 0.0f;
	currentmotion = IDLE;

	geVec3d_Set(&translation,0.0f,0.0f,0.0f);
	geVec3d_Set(&rotation,0.0f,0.0f,0.0f);
}

Dummy::~Dummy()
{
	if(def)
	{
		geActor_DefDestroy(&def);
		def = NULL;
	}

	if(actor)
	{
		geActor_Destroy(&actor);
		actor = NULL;
	}
}

bool Dummy::Load(char *szName)
{
	file  = geVFile_OpenNewSystem(NULL,GE_VFILE_TYPE_DOS,szName,NULL,GE_VFILE_OPEN_READONLY);

	if(!file)
		return false;
	
	def   = geActor_DefCreateFromFile(file);
	
	if(!def)
		return false;

	actor = geActor_Create(def);
	
	if(!actor)
		return false;

	geWorld_AddActor(CD->getm_World()->getWorld(),actor,GE_ACTOR_RENDER_NORMAL | GE_ACTOR_COLLIDE,0xffffffff);

	geActor_SetScale(actor,1.0f,1.0f,1.0f);

	geVec3d normal = { 0.0f, 1.0f, 0.0f };
	geActor_SetLightingOptions(actor,GE_TRUE,&normal,255.0f,255.0f,255.0f,1.0f,1.0f,1.0f,GE_TRUE,3,NULL,GE_FALSE);

	geXForm3d_SetIdentity(&xform);

	geXForm3d_RotateZ(&xform,rotation.Z);
	geXForm3d_RotateX(&xform,rotation.X);
	geXForm3d_RotateY(&xform,rotation.Y);
	geXForm3d_Translate(&xform,translation.X,translation.Y,translation.Z);

	geActor_ClearPose(actor,&xform);

	geVFile_Close(file);

	return true;
}

void Dummy::Update()
{
	Animate();
}

void Dummy::Animate()
{
	float start,end;

	geXForm3d_SetIdentity(&xform);

	geXForm3d_RotateZ(&xform,rotation.Z);
	geXForm3d_RotateX(&xform,rotation.X);
	geXForm3d_RotateY(&xform,rotation.Y);

	geXForm3d_Translate(&xform,translation.X,translation.Y,translation.Z);

	switch(currentmotion)
	{
		case IDLE:
			motion = geActor_GetMotionByName(def,"Idle");
			break;
	}

	geActor_SetPose(actor,motion,counter,&xform);

	geMotion_GetTimeExtents(motion,&start,&end);

	counter += 0.005f;

	if(counter >= end)
		counter = 0.0f;
}
