
#ifndef _ENGINE_H_
#define _ENGINE_H_

class Engine
{
public:
	Engine();
   ~Engine();

    bool CreateEngine(HINSTANCE hInstance);
	int  Begin();
	int  End();
	int  Render();
	void Logo(char *szName);
	void FrameRate(bool enbale);
	void Print(int x,int y,char *szString);

	HWND            gethWnd();
	int             getWidth();
	int             getHeight();
	char           *getLevel();
	geEngine       *getEngine();
	geSound_System *getSoundSystem();
private:
	HWND             hWnd;
	HINSTANCE        hInstance;
	int              Width,Height;
	char            *szName;
	char             DrvName;
	char            *DrvDirectory;
	char            *LevelName;
	float            Gamma;
	geEngine        *engine;
	geDriver_System *DrvSys;
	geDriver        *Drv;
	geDriver_Mode   *DrvMode;
	geSound_System  *SoundSys;
	int              MasterVolume;
	
	bool Create(HINSTANCE hInstance);
	bool FindDriver();
};

#define MAX_NUMBER_OF_CAMERAS 12

class Camera
{
public:
	Camera();
   ~Camera();

    bool CreateCamera();
	void WorldSpaceXForm();
	void SetTranslation(float X,float Y,float Z);
	void SetRotation(float X,float Y,float Z);

	geCamera *getCamera();
	geVec3d   getTranslation();
	geVec3d   getRotation();
	geXForm3d getXForm();
private:
	geCamera *camera;
	geRect    Rect;
	geVec3d   Translation;
	geVec3d   Rotation;
	geVec3d   Direction;
	geXForm3d XForm;
	geExtBox  Box;
	float     DefaultDistance;
	float     CurrentDistance;

	bool Create();
};

#define MAX_NUMBER_OF_WORLDS 8

class World
{
public:
	World();
   ~World();

    bool Loadbsp(char *szName);
	void NoWorld();
	
	geWorld *getWorld();
private:
	geWorld *world;
	geVFile *File;
};

#define MAX_NUMBER_OF_SOUNDS 2

typedef enum SOUND_ID
{
	SOUND_ACQUIRE = 0,
	SOUND_CLICK,
};

class Sound
{
public:
	Sound();
   ~Sound();

    bool Load(char *szName);
	void Play();

private:
	geSound        *sound;
	geSound_Def    *Def;
	geXForm3d       XForm;
	geVec3d         Vector;
	geFloat         Vol,Fan,Freq;
};

inline HWND            Engine::gethWnd()        { return hWnd;        }
inline int             Engine::getWidth()       { return Width;       }
inline int             Engine::getHeight()      { return Height;      }
inline char           *Engine::getLevel()       { return LevelName;   }
inline geEngine       *Engine::getEngine()      { return engine;      }
inline geSound_System *Engine::getSoundSystem() { return SoundSys;    }

inline geCamera       *Camera::getCamera()      { return camera;      }
inline geVec3d         Camera::getTranslation() { return Translation; }
inline geVec3d         Camera::getRotation()    { return Rotation;    }
inline geXForm3d       Camera::getXForm()       { return XForm;       }

inline geWorld        *World::getWorld()        { return world;       }

#endif