
#ifndef _ENTITY_H_
#define _ENTITY_H_

typedef enum
{
	ITEM_MEDKIT = 0,
	ITEM_GRENADE,
	ITEM_ARMOR,
	ITEM_ROCKET,
	ITEM_SHREDDER,
};

typedef struct ITEM_ENTITY_INFO
{
	int type;
}ITEM_ENTITY_INFO;

typedef struct DeathMatchStart
{
#pragma GE_Published
	geVec3d Origin;

#pragma GE_Origin(Origin)
}DeathMatchStart;

#define MAX_NUMBER_OF_ITEMS 12

typedef struct ITEM
{
#pragma GE_Published
	geVec3d  Origin;
	int      Type;
	char    *szName;

#pragma GE_Origin(Origin)
#pragma GE_DefaultValue(Type,"0")
#pragma GE_DefaultValue(szName,"data\\.act")

#pragma GE_Private
	geActor *actor;
}ITEM;

typedef struct LIGHT
{
#pragma GE_Published
	geVec3d  Origin;
	geFloat  Radius;
	GE_RGBA  Color;

#pragma GE_Origin(Origin)
#pragma GE_DefaultValue(Radius,"500.0f");
#pragma GE_DefaultValue(Color,"255.0f,255.0f,255.0f")

#pragma GE_Private
	geLight *light;
}LIGHT;

void    LoadEntity();
void    LoadItem();
void    LoadLight();
void    DeleteEntity();
int     EntityCollision(ITEM_ENTITY_INFO *info);
geVec3d Gravity(geVec3d pos,geExtBox box);

#endif