
//-- game releated classes, not engines

#ifndef GAME_H
#define GAME_H

#define MAX_NUMBER_OF_MENU_IMAGES 4

typedef enum
{
	MENU_IMAGE_NEWGAME = 0,
	MENU_IMAGE_QUIT,
	MENU_IMAGE_OK,
	MENU_IMAGE_CANCEL,
};

class GameMenu
{
public:
	GameMenu();
   ~GameMenu();

    void Load();
	void ProcessMenu();
	void ProcessSelect();

	Dummy *getm_Dummy();
    Image *getm_Image(int type);
private:
	geCamera *camera;
	geRect    rect;
	geVec3d   translation;
	geVec3d   rotation;
	geXForm3d xform;
	Dummy    *m_Dummy;
	Light    *m_Light;
	Image    *m_Image[MAX_NUMBER_OF_MENU_IMAGES];
};

typedef enum
{
	GAMESTATE_MENU = 0,
	GAMESTATE_SELECT,
	GAMESTATE_LOOP,
	GAMESTATE_QUIT,
};

class Game
{
public:
	Game();
   ~Game();

    int  getState();
	void setState(int m_state);
private:
	int state;
};

inline Dummy    *GameMenu::getm_Dummy()         { return m_Dummy;       }
inline Image    *GameMenu::getm_Image(int type) { return m_Image[type]; }

inline int       Game::getState()               { return state;         }
inline void      Game::setState(int m_state)    { state = m_state;      }  

#endif
