
#include "Header.h"


GameCharacterSelect::GameCharacterSelect()
{
	camera = NULL;
	geVec3d_Set(&translation,0.0f,0.0f,0.0f);
	geVec3d_Set(&rotation,0.0f,0.0f,0.0f);

	for(int i = 0; i < MAX_NUMBER_OF_CHARACTERSELECT_IMAGES; i++)
		m_Image[i] = NULL;
}

GameCharacterSelect::~GameCharacterSelect()
{
	for(int i = 0; i < MAX_NUMBER_OF_CHARACTERSELECT_IMAGES; i++)
		N_DELETE(m_Image[i]);

	if(camera)
	{
		geCamera_Destroy(&camera);
		camera = NULL;
	}
}

bool GameCharacterSelect::Init()
{
	rect.Left   = 0;
	rect.Top    = 0;
	rect.Right  = CD->getm_Engine()->getWidth() - 1;
	rect.Bottom = CD->getm_Engine()->getHeight() - 1;

	camera = geCamera_Create(2.0f,&rect);

	if(!camera)
		return false;

	for(int i = 0; i < MAX_NUMBER_OF_CHARACTERSELECT_IMAGES; i++)
	{
		m_Image[i] = new Image();
		N_DETECT_NULL(m_Image[i],"Unable to allocate memory to m_Image");
	}

	return true;
}

void GameCharacterSelect::Do()
{
}