
#include "Header.h"


Menu::Menu()
{
	m_Background = NULL;

	for(int n = 0; n < MAX_NUMBER_OF_IMAGES; n++)
		m_Images[n] = NULL;

	KeyDown = true;

	ShowCursor(true);
}

Menu::~Menu()
{
	for(int n = 0; n < MAX_NUMBER_OF_IMAGES; n++)
		N_DELETE(m_Images[n]);

	N_DELETE(m_Background);
}

void Menu::Load()
{
	m_Background = new Image();
	N_DETECT_NULL(m_Background,"Unable to allocate memory to Background");
	N_DETECT(m_Background->Load("bmp\\background.bmp",0,0),"failed to call m_Background->Load()");

	for(int n = 0; n < MAX_NUMBER_OF_IMAGES; n++)
	{
		m_Images[n] = new Image();
		N_DETECT_NULL(m_Images[n],"Unable to allocate memory to m_Images[n]");
	}

	m_Images[MENU_START]  ->Load("bmp\\01.bmp",30,40);
	m_Images[MENU_EXIT]   ->Load("bmp\\02.bmp",30,75);
	m_Images[MENU_CREDITS]->Load("bmp\\03.bmp",30,110);
	m_Images[MENU_START]  ->setID(MENU_START);
	m_Images[MENU_EXIT]   ->setID(MENU_EXIT);
	m_Images[MENU_CREDITS]->setID(MENU_CREDITS);
}

void Menu::Process()
{
	CD->getm_Engine()->Begin();
	
	m_Background->Draw();
	
	for(int n = 0; n < MAX_NUMBER_OF_IMAGES; n++)
	{
		m_Images[n]->Draw();

		if(m_Images[n]->MouseOver())
		{
			switch(m_Images[n]->getID())
			{
				case MENU_START:
					CD->getm_Font()->Out(30,160,"start the game");

					if(CD->getm_Keyboard()->GetDown(VK_LBUTTON) && KeyDown)
					{
						CD->getm_Sound(SOUND_CLICK)->Play();
						CD->setState(STATE_START);
						ShowCursor(false);
						KeyDown = false;
					}
					break;
				case MENU_EXIT:
					CD->getm_Font()->Out(30,160,"exit the game >:(");

					if(CD->getm_Keyboard()->GetDown(VK_LBUTTON) && KeyDown)
					{
						CD->getm_Sound(SOUND_CLICK)->Play();
						CD->setState(STATE_EXIT);
						KeyDown = false;
					}
					break;
				case MENU_CREDITS:
					CD->getm_Font()->Out(30,160,"programmed by SSFAN :)");

					if(CD->getm_Keyboard()->GetDown(VK_LBUTTON) && KeyDown)
					{
						CD->getm_Sound(SOUND_CLICK)->Play();
						KeyDown = false;	
					}
					break;
			}

			if(CD->getm_Keyboard()->GetUp(VK_LBUTTON))
				KeyDown = true;
		}
	}

	CD->getm_Engine()->End();
}