
#ifndef _PLAYER_H_
#define _PLAYER_H_

typedef enum
{
	AIM = 0,
	C_AIM,
	C_IDLE,
	C_JUMPSTART,
	C_LAND,
	C_SHOOT,
	C2IDLE,
	CRAWL,
	FALL,
	FALLSHOOT,
	I2RUN,
	I2WALK,
	IDLE,
	JUMP,
	JUMPSHOOT,
	JUMPSTART,
	LAND,
	RUN,
	RUNSHOOT,
	SHOOT,
	SSTRAFELEFT,
	SSTRAFERIGHT,
	STRAFELEFT,
	STRAFERIGHT,
	W2IDLE,
	WALK,
	WALKSHOOT,
};

typedef enum PLAYER_TYPE
{
	TYPE_SPAWN = 0,
};

class Player
{
public:
	Player();
   ~Player();

    bool Load(char *szName);
	void SetType(int type);
	void MoveToDeathMatchStart();
	void MoveTo(float x,float y,float z);
	void MouseLook();
	void Control();
	void Update();
	
	geActor  *getActor();
	geVec3d   getTranslation();
	geVec3d   getRotation();
	geXForm3d getXForm();
	float     getHeight();
	int       getType();

	void      Motion(int motion);
private:
	geActor     *Actor;
	geActor_Def *Def;
	geVFile     *File;
	geVec3d      Translation;
    geVec3d      Rotation;
	geVec3d      Direction;
	geExtBox     Box;
	geXForm3d    XForm;
	float        Height;
	float        Getup;
	float        Speed;
	float        StepHeight;
	int          Reverse;

	geMotion    *motion;
	float        Counter;
	int          CurrentMotion;

	bool         OnGround;
	bool         Jumping;
	bool         Falling;
	bool         GravityOn;
	bool         Crouch;
	bool         Aim;
	float        gravity;
	float        Acceleration;
	float        JumpHeight;

	int          Type;

	void Move(int reverse);
	void Move(int reverse,float speed);
	void ProcessActorCollision(int type,geActor *actor);
	void Forward();
	void Backward();
	void Left();
	void Right();
	void Jump();

	void StandGravity();
	void Gravity();
	void Animate();
};

inline geActor  *Player::getActor()       { return Actor;       }
inline geVec3d   Player::getTranslation() { return Translation; }
inline geVec3d   Player::getRotation()    { return Rotation;    }
inline geXForm3d Player::getXForm()       { return XForm;       }
inline float     Player::getHeight()      { return Height;      }
inline int       Player::getType()        { return Type;        }

#endif
